unit PCF8574;

interface

uses I2CCOM2, PORTINC,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Timer1: TTimer;
    Label9: TLabel;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    Label10: TLabel;
    Edit1: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  end;

var
  Form1: TForm1;
  Dout, Din, Ain: Byte;
  Fehler: Boolean;
implementation

{$R *.DFM}

Procedure ParallelAus (Wert: Byte);
begin
  Start;
  Fehler:=Not(Ausgeben (32 * 2)); {Adr 32, Ack?}
  Ausgeben (Wert);
  Stop;
end;

function ParallelEin : Byte;
begin
  Start;
  Fehler:=Not(Ausgeben (32 * 2 + 1)); {Adr 32, lesen}
  ParallelEin := Einlesen;
  KeinAcknowledge;
  Stop;
end;




procedure TForm1.FormCreate(Sender: TObject);
begin
  I2C_Init;
  Timer1.Interval := 100;
  Timer1.Enabled := true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Dout := 0;
  if  CheckBox1.Checked Then Dout := Dout +1;
  if  CheckBox2.Checked Then Dout := Dout +2;
  if  CheckBox3.Checked Then Dout := Dout +4;
  if  CheckBox4.Checked Then Dout := Dout +8;
  if  CheckBox5.Checked Then Dout := Dout +16;
  if  CheckBox6.Checked Then Dout := Dout +32;
  if  CheckBox7.Checked Then Dout := Dout +64;
  if  CheckBox8.Checked Then Dout := Dout +128;
  ParallelAus (Dout);
  If Fehler Then Edit1.Text := 'IC antwortet nicht'
   else Edit1.Text := 'PCF8574 adressiert';

  Din := ParallelEin;
  CheckBox9.Checked := ((Din And 1) >0);
  CheckBox10.Checked := ((Din And 2) >0);
  CheckBox11.Checked := ((Din And 4) >0);
  CheckBox12.Checked := ((Din And 8) >0);
  CheckBox13.Checked := ((Din And 16) >0);
  CheckBox14.Checked := ((Din And 32) >0);
  CheckBox15.Checked := ((Din And 64) >0);
  CheckBox16.Checked := ((Din And 128) >0);
 end;

end.
