unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ComCtrls, ExtCtrls;

function capCreateCaptureWindowA(lpName:pchar;dwStyle:DWORD;
         x,y,w,h,HWnd,nID:integer):integer; stdcall;external 'AVICAP32.DLL';


type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Beenden1: TMenuItem;
    Bearbeiten1: TMenuItem;
    Quelle1: TMenuItem;
    Gre1: TMenuItem;
    Display1: TMenuItem;
    Compress1: TMenuItem;
    N1: TMenuItem;
    Overlay1: TMenuItem;
    Preview1: TMenuItem;
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure Quelle1Click(Sender: TObject);
    procedure Gre1Click(Sender: TObject);
    procedure Display1Click(Sender: TObject);
    procedure Compress1Click(Sender: TObject);
    procedure Overlay1Click(Sender: TObject);
    procedure Preview1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const//Aus "AVICAP.H" Header-Datei
     WM_CAP_START=                    WM_USER;
     WM_CAP_DRIVER_GET_CAPS          =(WM_CAP_START+  14);
     WM_CAP_DRIVER_CONNECT           =(WM_CAP_START+  10);
     WM_CAP_DRIVER_DISCONNECT        =(WM_CAP_START+  11);
     WM_CAP_DLG_VIDEOFORMAT          =(WM_CAP_START+  41);
     WM_CAP_DLG_VIDEOSOURCE          =(WM_CAP_START+  42);
     WM_CAP_DLG_VIDEODISPLAY         =(WM_CAP_START+  43);
     WM_CAP_GET_VIDEOFORMAT          =(WM_CAP_START+  44);
     WM_CAP_SET_VIDEOFORMAT          =(WM_CAP_START+  45);
     WM_CAP_DLG_VIDEOCOMPRESSION     =(WM_CAP_START+  46);

     WM_CAP_SET_PREVIEW              =(WM_CAP_START+  50);
     WM_CAP_SET_OVERLAY              =(WM_CAP_START+  51);
     WM_CAP_SET_PREVIEWRATE          =(WM_CAP_START+  52);
     WM_CAP_SET_SCALE                =(WM_CAP_START+  53);
     WM_CAP_GET_STATUS               =(WM_CAP_START+  54);
     WM_CAP_SET_SCROLL               =(WM_CAP_START+  55);
     WM_CAP_GRAB_FRAME               =(WM_CAP_START+  60);
     WM_CAP_GRAB_FRAME_NOSTOP        =(WM_CAP_START+  61);

VAR  cwnd:HWND;


procedure TForm1.FormCreate(Sender: TObject);
begin
   cwnd := capCreateCaptureWindowA
            (nil,          // Window name if popup
            WS_CHILD + WS_VISIBLE +WS_OVERLAPPED,// window style
	    0,0, clientwidth, clientheight,           // window position and
	    handle,
	    1);
   ShowWindow  (cwnd,SW_SHOW);
   SendMessage (cwnd, WM_CAP_DRIVER_CONNECT, 0, 0);
   SendMessage (cwnd, WM_CAP_SET_PREVIEWRATE, 100 , 0);
   SendMessage (cwnd, WM_CAP_SET_OVERLAY, 1 , 0);

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   SendMessage (cwnd, WM_CAP_DRIVER_DISCONNECT, 0, 0);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
     MoveWindow(cwnd,0,0,clientwidth,clientheight-statusbar1.height,false);
end;

procedure TForm1.Beenden1Click(Sender: TObject);
begin
     close
end;

procedure TForm1.Quelle1Click(Sender: TObject);
begin
     SendMessage (cwnd, WM_CAP_DLG_VIDEOSOURCE, 0, 0);
end;

procedure TForm1.Gre1Click(Sender: TObject);
begin
     SendMessage (cwnd, WM_CAP_DLG_VIDEOFORMAT, 0, 0);
end;

procedure TForm1.Display1Click(Sender: TObject);
begin
 SendMessage (cwnd, WM_CAP_DLG_VIDEODISPLAY, 0, 0);
end;

procedure TForm1.Compress1Click(Sender: TObject);
begin
 SendMessage (cwnd, WM_CAP_DLG_VIDEOCOMPRESSION, 0, 0);
end;

procedure TForm1.Overlay1Click(Sender: TObject);
begin
 SendMessage (cwnd, WM_CAP_SET_OVERLAY, 1 , 0);
end;

procedure TForm1.Preview1Click(Sender: TObject);
begin
 SendMessage (cwnd, WM_CAP_SET_PREVIEW, 1 , 0);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var r,g,b,c,hdc:Integer;
begin
   hdc:=getdc(cwnd);
   c:=getpixel(hdc,0,0);
   releasedc(cwnd,hdc);
   r:=c and $FF;
   g:=(c shr  8) and $FF;
   b:=(c shr 16) and $FF;
   Statusbar1.simpletext:=Format('ROT:%03d GRN:%03d BLAU:%03d',[r,g,b]);
end;

end.
