unit ICtest;

interface

uses PORTINC,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Timer1: TTimer;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    SaveAs1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
  end;

var
  Form1: TForm1;
  Dout, Din, Ain: Byte;
  n: Integer;
  Ausgaenge: Array[0..255] of Byte;
  Testfile: File of Byte;
  Dateiname: String;
implementation

{$R *.DFM}

procedure Austausch;
var Stelle, StelleAD, n, m  : Integer;
begin
  RTS (1);               { Strobe an }
  Delayus(20);           { Verzgerung }
  RTS (0);               { Strobe aus }
  Stelle := 1;
  StelleAD := 128;
  Din := 0;
  Ain := 0;
  for n:=1 to 8 do begin
    if ((Dout AND Stelle) > 0) then
      TXD (1)            { Daten ausgeben }
      else TXD (0);
    if DCD = 1           { Daten lesen }
       then Din := Din + Stelle;
    if DSR = 1 then      { A/D lesen }
       Ain := Ain + StelleAD;
    DTR (1);             { Clock an }
  Delayus(20);           { Verzgerung }
    DTR (0);             { Clock aus }
    Stelle := Stelle * 2;
    StelleAD := StelleAD div 2;
  end;
  RTS (1);               { Strobe an }
  Delayus(20);           { Verzgerung }
  RTS (0);               { Strobe aus }
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenCom(pchar('com2:9600,N,8,1'));
end;

procedure TForm1.Button3Click(Sender: TObject);
var n: Integer;
begin
{Dateiname := OpenDialog.FileName;}
Dateiname := 'TEST.BIN';
AssignFile (Testfile,Dateiname);
{$I-} Rewrite (Testfile) {$I+};
for n:= 0 to 255 do begin;
  write (Testfile, Ausgaenge[n]);
end;
CloseFile (Testfile);
end;

procedure TForm1.Button2Click(Sender: TObject);
var Wert: Word;
    Spannung, Fehler : Real;
begin
  Timer1.Enabled := false;
  Fehler := 0;
  Edit1.Text := 'Test ...';
  for n := 1 to 255 do begin
    Dout := n;
    Austausch;
    Delay (1);
    Austausch;
    If (Ain > 10) or (Din <> Ausgaenge[n]) then begin
      Fehler := Fehler + 1;
      Spannung := Ain/255*5;
      Edit1.Text := FloatToStr(N) + ', ' +
      FloatToStr(Din) + '<> '+FloatToStr(Ausgaenge[n]) +
      '  '+ FloatToStrF(Spannung,ffGeneral,3,2) + ' mA';
    end;
  end;
  If Fehler = 0 then Edit1.Text := 'Test O.K.';
  Timer1.Interval := 2000;
  Timer1.Enabled := true;
end;

procedure TForm1.Button1Click(Sender: TObject);
var n: Integer;
begin
{Dateiname := OpenDialog.FileName;}
Timer1.Enabled := false;
for n:= 0 to 255 do begin;
  Dout := n;
  Austausch;
  Delay (1);
  Austausch;
  Ausgaenge[n] := Din;
end;
Edit1.text := 'Fertig';
Timer1.Enabled := true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  Edit1.Text := 'bereit';
  Timer1.Enabled := false
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  OpenDialog1.FileName := '*.bin';
  OpenDialog1.Execute;
  Dateiname := OpenDialog1.FileName;
  if Dateiname > '' then begin
    AssignFile (Testfile,Dateiname);
    {$I-} Reset (Testfile) {$I+};
    for n:= 0 to 255 do read (Testfile,Ausgaenge[n]);
    CloseFile (Testfile);
  end
end;

procedure TForm1.SaveAs1Click(Sender: TObject);
  var n: Integer;
begin
  SaveDialog1.FileName := '*.bin';
  SaveDialog1.Execute;
  Dateiname := SaveDialog1.FileName;
  If Dateiname > '' then begin
    AssignFile (Testfile,Dateiname);
    {$I-} Rewrite (Testfile) {$I+};
    for n:= 0 to 255 do write (Testfile, Ausgaenge[n]);
    CloseFile (Testfile);
  end;
end;

end.
