unit Logik;

interface

uses I2CCOM2, PORTINC,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    Start: TButton;
    procedure FormCreate(Sender: TObject);
    procedure StartClick(Sender: TObject);
  end;

var
  Form1: TForm1;
  Puffer : Array [1..5000] of Byte;

implementation

{$R *.DFM}

procedure ParallelAus (Wert: Byte);
begin
  Start;
  Ausgeben (32 * 2);        { Adresse 32, schreiben }
  Ausgeben (Wert);
  Stop;                     
end;                        

function ParallelEin : Byte;
begin
  Start;
  Ausgeben (32 * 2 + 1);    { Adresse 32, lesen }
  ParallelEin := Einlesen;
  KeinAcknowledge;
  Stop;
end;

procedure Serie;
var Dummy : Byte;
    m, n: Word;
begin
  ParallelAus (255);
  Start;
  Ausgeben (32 * 2 + 1);       { Adresse 32, lesen }
  for n := 1 to 400 do begin;
     Puffer [n] := Einlesen;   { 400 mal Daten lesen }
     Acknowledge;              { Empfang besttigen }
     delay (10);
  end;
  Dummy := Einlesen;           { einmal einlesen }
  KeinAcknowledge;             { nicht besttigen }
  Stop;                        { abmelden }
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  I2C_Init;
  Paintbox1.Canvas.Pen.Color:=ClBlack;
  Paintbox1.Canvas.Brush.Color:=ClWhite;
  PaintBox1.Canvas.Rectangle(0,0,400,160);
end;

procedure TForm1.StartClick(Sender: TObject);
var n, m, Wert: Integer;
begin
  Serie;
  Paintbox1.Canvas.Pen.Color:=ClLtGray;
  Paintbox1.Canvas.Brush.Color:=ClWhite;
  PaintBox1.Canvas.Rectangle(0,0,401,161);
  for n:= 1 to 8 do begin
      paintbox1.canvas.MoveTo(0,n*20);
      Paintbox1.Canvas.Lineto (400,n*20);
  end;
  Paintbox1.Canvas.Pen.Color:=ClBlack;
  Wert := 1;
  for n := 1 to 8 do begin
    for m := 2 to 400 do begin
      paintbox1.canvas.MoveTo (m-1,n*20-12*((Puffer[m-1] and Wert) div Wert));
      Paintbox1.Canvas.Lineto  (m,n*20-12*((Puffer[m] and Wert) div Wert));
    end;
    Wert := Wert * 2;
  end;

end;

end.

