unit palcappas;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls,mmsystem, OleCtrls,Menus, ToolWin;
//  The only exported functions from AVICAP.DLL        getdc
function capCreateCaptureWindowA(lpName:pchar;dwStyle:DWORD;
           x,y,w,h,HWnd,nID:integer):integer; stdcall;external 'AVICAP32.DLL';

type
  TForm1 = class(TForm)
    ToolBar1: TToolBar;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    PaintBox1: TPaintBox;
    Timer1: TTimer;
    Zeile: TScrollBar;
    C1: TCheckBox;
    C2: TCheckBox;
    C3: TCheckBox;
    C4: TCheckBox;
    Label1: TLabel;
    Zeile2: TScrollBar;
    CONL: TScrollBar;
    CONR: TScrollBar;
    Label2: TLabel;
    CTIMER: TCheckBox;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Beebden1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure CTIMERClick(Sender: TObject);
    procedure Beebden1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

  const
     WM_CAP_START=                    WM_USER;
     WM_CAP_DRIVER_GET_CAPS          =(WM_CAP_START+  14);
     WM_CAP_DRIVER_CONNECT           =(WM_CAP_START+  10);
     WM_CAP_DRIVER_DISCONNECT        =(WM_CAP_START+  11);
     WM_CAP_DLG_VIDEOFORMAT          =(WM_CAP_START+  41);
     WM_CAP_DLG_VIDEOSOURCE          =(WM_CAP_START+  42);
     WM_CAP_DLG_VIDEODISPLAY         =(WM_CAP_START+  43);
     WM_CAP_GET_VIDEOFORMAT          =(WM_CAP_START+  44);
     WM_CAP_SET_VIDEOFORMAT          =(WM_CAP_START+  45);
     WM_CAP_DLG_VIDEOCOMPRESSION     =(WM_CAP_START+  46);

     WM_CAP_SET_PREVIEW              =(WM_CAP_START+  50);
     WM_CAP_SET_OVERLAY              =(WM_CAP_START+  51);
     WM_CAP_SET_PREVIEWRATE          =(WM_CAP_START+  52);
     WM_CAP_SET_SCALE                =(WM_CAP_START+  53);
     WM_CAP_GET_STATUS               =(WM_CAP_START+  54);
     WM_CAP_SET_SCROLL               =(WM_CAP_START+  55);
     WM_CAP_GRAB_FRAME               =(WM_CAP_START+  60);
     WM_CAP_GRAB_FRAME_NOSTOP        =(WM_CAP_START+  61);

     VH=284;
     VW=384;

type Tp=array[0..VW]of Tpoint;

var
  Form1: TForm1;
  cwnd:integer;
  bm:TBitmap;
  pcm:real=10;

implementation

{$R *.DFM}


procedure TForm1.Button1Click(Sender: TObject);
begin
     SendMessage (cwnd, WM_CAP_DLG_VIDEOFORMAT, 0, 0);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   bm:=Tbitmap.Create;
   bm.width:=VW;
   bm.height:=VH;

   cwnd := capCreateCaptureWindowA
           (pchar('My Capture Window'), // Window name if popup
            WS_CHILD + WS_VISIBLE +WS_OVERLAPPED,// window style
	    0,toolbar1.height, VW, VH,              // window position and
	    handle,
	    1);
   ShowWindow(cwnd,SW_SHOW);
   SendMessage (cwnd, WM_CAP_DRIVER_CONNECT, 0, 0);
   SendMessage (cwnd, WM_CAP_SET_PREVIEWRATE, 100 , 0);
   SendMessage (cwnd, WM_CAP_SET_OVERLAY, 1 , 0);

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     SendMessage (cwnd, WM_CAP_DLG_VIDEOSOURCE, 0, 0);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     SendMessage (cwnd, WM_CAP_DLG_VIDEODISPLAY, 0, 0);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
     SendMessage (cwnd, WM_CAP_DLG_VIDEOCOMPRESSION, 0, 0);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
     SendMessage (cwnd, WM_CAP_SET_OVERLAY, 1 , 0);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
     SendMessage (cwnd, WM_CAP_SET_PREVIEW, 1 , 0);
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
 //BitBlt(bm.canvas.handle,0,0,VW,VH,form1.canvas.handle,0,toolbar1.height,SRCCOPY);
  SendMessage (cwnd, WM_CAP_GRAB_FRAME, 0, 0);
  timer1.enabled:=false;
  ctimer.checked:=false;
  Timer1Timer(Sender);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   SendMessage (cwnd, WM_CAP_DRIVER_DISCONNECT, 0, 0);
   bm.free;
end;

function lmin(ix:integer;pt:tp):integer;
var mi,i,y:integer;
begin
     mi:=0;i:=ix;
     while i<(VW-10) do
     begin
          y:=pt[i].y;
          if y>mi then begin ix:=i;mi:=pt[i].y; end;
          inc(i);
     end;
     result:=ix;
end;

function rmin(ix:integer;pt:tp):integer;
var mi,i,y:integer;
begin
     mi:=0;i:=ix;
     while i>(3) do
     begin
          y:=pt[i].y;
          if y>mi then begin ix:=i;mi:=pt[i].y; end;
          dec(i);
     end;
     result:=ix;
end;

function lcon(ix:integer;pt:tp):integer;
var i,y,yy,c:integer;
begin
     result:=0;
     c:=form1.CONL.Position;
     i:=ix;
     while i<(vw-10) do
     begin
           y:=pt[i].y;
          yy:=pt[i+2].y;
          if yy>(c+y) then begin result:=i; exit; end;
          inc(i);
     end;
end;

function rcon(ix:integer;pt:tp):integer;
var i,y,yy,c:integer;
begin
     result:=0;
     c:=form1.CONR.Position;
     i:=ix;
     while i>3 do
     begin
           y:=pt[i].y;
          yy:=pt[i-3].y;
          if yy>(c+y) then begin result:=i; exit; end;
          dec(i);
     end;
end;
procedure ScanClear;
begin
     with bm.canvas do
     begin
          Brush.Style:=bsSolid;
          Brush.color:=clgreen;
          pen.color:=brush.color;
          Rectangle(0,0,bm.width,bm.height);
     end;
end;

procedure ScanHcm;
var x,y,z,w,h,r,g,b,x1,x2,x3:integer; c:TColor;   hdc:integer;
    pr,pg,pb,pa:tp;
begin
     hdc:=getdc(cwnd);
     z:=form1.zeile.position;
     with bm.canvas do
     begin
          w:=bm.width;
          h:=bm.height;
          for x:=0 to VW do
          begin
               c:=getpixel(hdc,x,z);
               setpixel(hdc,x,z,clred);
               r:=c and $FF;
               g:=(c shr  8) and $FF;
               b:=(c shr 16) and $FF;
               pr[x].x:=x;pr[x].y:=255-r;
               pg[x].x:=x;pg[x].y:=255-g;
               pb[x].x:=x;pb[x].y:=255-b;
               pa[x].x:=x;pa[x].y:=255-(r+g+b) div 3;
          end;
          //if form1.c1.checked then begin  pen.color:=clred;   polyline(pr); end;
          //if form1.c2.checked then begin  pen.color:=cllime; polyline(pg); end;
          //if form1.c3.checked then begin  pen.color:=clblue;  polyline(pb); end;
          //if form1.c4.checked then begin  pen.color:=clgray;  polyline(pa); end;
          x1:=lmin(   3,pa);//Minimum
          x2:=lmin(x1+3,pa); //rechts
          x3:=rmin(x1-3,pa); //links
          if pa[x3].y>pa[x2].y then x2:=x3;
          if x1>x2 then begin x:=x1; x1:=x2; x2:=x; end;
          w:=x2-x1;  h:=w div 5;
          if w>5 then
          begin
               pcm:=w+1.75;
               pen.color:=clgray;
               x:=0;
               repeat
                moveto(x,0);lineto(x,VH);
                if w>25 then for y:= 1 to 4 do
                begin
                     moveto(x+(y*h),VH);lineto(x+(y*h),VH-5);
                     moveto(x+(y*h), 0);lineto(x+(y*h),   5);
                end;
                x:=x+w;
               until x>vw;
               y:=0;
               repeat
                moveto(0,y);lineto(vw,y);
                if w>25 then for x:= 1 to 4 do
                begin
                     moveto(0,y+(x*h));lineto(5,y+(x*h));
                     moveto(vw,y+(x*h));lineto(vw-5,y+(x*h));
                end;
                y:=y+w;
               until y>vh;
          end;
          pen.color:=clred;   moveto(x1,VH);lineto(x1,VH-10);
          pen.color:=clblack; moveto(x2,VH);lineto(x2,VH-10);
     end;
     releasedc(cwnd,hdc);
end;

procedure ScanW;
var x,y,z,w,h,r,g,b,x1,x2,x3:integer; c:TColor;   hdc:integer;
    pr,pg,pb,pa:tp;
begin
     hdc:=getdc(cwnd);
     z:=form1.zeile2.position;
     with bm.canvas do
     begin
          w:=bm.width;
          h:=bm.height;
          for x:=0 to VW do
          begin
               c:=getpixel(hdc,x,z);
               setpixel(hdc,x,z,clblue);
               r:=c and $FF;
               g:=(c shr  8) and $FF;
               b:=(c shr 16) and $FF;
               pr[x].x:=x;pr[x].y:=255-r;
               pg[x].x:=x;pg[x].y:=255-g;
               pb[x].x:=x;pb[x].y:=255-b;
               pa[x].x:=x;pa[x].y:=255-(r+g+b) div 3;
          end;
          if form1.c1.checked then begin  pen.color:=clred;   polyline(pr); end;
          if form1.c2.checked then begin  pen.color:=cllime; polyline(pg); end;
          if form1.c3.checked then begin  pen.color:=clblue;  polyline(pb); end;
          if form1.c4.checked then begin  pen.color:=clgray;  polyline(pa); end;
          x1:=lcon(   3,pa);//links
          x2:=rcon(vw-10,pa); //rechts
          w:=x2-x1;
          if x1>x2 then begin x:=x1; x1:=x2; x2:=x; end;
          pen.color:=clyellow;   moveto(x1,VH);lineto(x1,VH-10);
          pen.color:=clyellow;   moveto(x2,VH);lineto(x2,VH-10);
     end;
     releasedc(cwnd,hdc);
     form1.label1.caption:=format('Breite: %4.1f mm',[10*w/pcm]);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin

     scanclear;
     scanhcm;
     scanw;
     form1.paintbox1.canvas.Draw(0,0,bm);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
form1.paintbox1.canvas.Draw(0,0,bm);
end;

procedure TForm1.CTIMERClick(Sender: TObject);
begin
timer1.enabled:=ctimer.Checked;
end;

procedure TForm1.Beebden1Click(Sender: TObject);
begin
close;
end;

end.

