unit Uni1;

interface

uses PORTINC,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Timer1: TTimer;
    Label9: TLabel;
    CheckBox9: TCheckBox;
    CheckBox10: TCheckBox;
    CheckBox11: TCheckBox;
    CheckBox12: TCheckBox;
    CheckBox13: TCheckBox;
    CheckBox14: TCheckBox;
    CheckBox15: TCheckBox;
    CheckBox16: TCheckBox;
    Label10: TLabel;
    Edit1: TEdit;
    Label11: TLabel;
    Edit2: TEdit;
    Label12: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  end;

var
  Form1: TForm1;
  Dout, Din, Ain: Byte;
implementation

{$R *.DFM}

procedure Austausch;
var Stelle, StelleAD, n, m  : Integer;
begin
  RTS (1);               { Strobe an }
  Delayus(20);           { Verzgerung }
  RTS (0);               { Strobe aus }
  Stelle := 1;
  StelleAD := 128;
  Din := 0;
  Ain := 0;
  for n:=1 to 8 do begin
    if ((Dout AND Stelle) > 0) then
      TXD (1)            { Daten ausgeben }
      else TXD (0);
    if DCD = 1           { Daten lesen }
       then Din := Din + Stelle;
    if DSR = 1 then      { A/D lesen }
       Ain := Ain + StelleAD;
    DTR (1);             { Clock an }
  Delayus(20);           { Verzgerung }
    DTR (0);             { Clock aus }
    Stelle := Stelle * 2;
    StelleAD := StelleAD div 2;
  end;
  RTS (1);               { Strobe an }
  Delayus(20);           { Verzgerung }
  RTS (0);               { Strobe aus }
end;

function Frequenz: Integer;
var Zaehler, alt, Eingang : Integer;
begin
  Zaehler := 0;
  RealTime (true);
  TimeInitus;
  alt:=CTS;
  while TimeReadus < (100000) do begin
    Eingang := CTS;
    if Eingang> alt then Zaehler := Zaehler +1;
    Alt := Eingang;
  end;
  Frequenz := Zaehler;
  RealTime (false);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenCom(pchar('com2:9600,N,8,1'));
  Timer1.Interval := 100;
  Timer1.Enabled := true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var Wert: Word;
    Spannung: Real;
begin
  Dout := 0;
  if  CheckBox1.Checked Then Dout := Dout +1;
  if  CheckBox2.Checked Then Dout := Dout +2;
  if  CheckBox3.Checked Then Dout := Dout +4;
  if  CheckBox4.Checked Then Dout := Dout +8;
  if  CheckBox5.Checked Then Dout := Dout +16;
  if  CheckBox6.Checked Then Dout := Dout +32;
  if  CheckBox7.Checked Then Dout := Dout +64;
  if  CheckBox8.Checked Then Dout := Dout +128;
  Austausch;
  CheckBox9.Checked := ((Din And 1) >0);
  CheckBox10.Checked := ((Din And 2) >0);
  CheckBox11.Checked := ((Din And 4) >0);
  CheckBox12.Checked := ((Din And 8) >0);
  CheckBox13.Checked := ((Din And 16) >0);
  CheckBox14.Checked := ((Din And 32) >0);
  CheckBox15.Checked := ((Din And 64) >0);
  CheckBox16.Checked := ((Din And 128) >0);
  Spannung := Ain/255*5;
  Edit1.Text := FloatToStrF(Spannung,ffGeneral,3,2) + ' V';
  Edit2.Text := FloatToStrF(Frequenz*10,ffGeneral,4,0) + ' Hz';
end;

end.
